public class A3Thread extends Thread {
  private final int ID;
  private final int N;
  private final int Z ;
  private volatile int actualA = 0;
  private volatile int desiredA = 0;
  private A3Thread shuffleTarget = null;
  private A3Thread exchangeTarget = null;
  private volatile int a;
  private final Object WAIT_FOR_A = new Object();
  private final Object WAIT_FOR_WRITE = new Object();

  public A3Thread(int id, int n, int z) {
    ID = id;
    N = n;
    Z = z;

    a = id;
  }

  public void setShuffleTarget(A3Thread target) {
    if (isAlive()) throw new UnsupportedOperationException("Thread already started");
    shuffleTarget = target;
  }

  public void setExchangeTarget(A3Thread target) {
    //System.out.println(ID+" to "+target.ID);
    if (isAlive()) throw new UnsupportedOperationException("Thread already started");
    exchangeTarget = target;
  }

  protected void setA(int newA, int step) {
    //System.out.println(ID+": setA("+newA+", "+step+")");
    synchronized(WAIT_FOR_WRITE) {
      while (step != desiredA) try {
        WAIT_FOR_WRITE.wait();
      } catch (InterruptedException e) {}
    }
    a = newA;
    actualA++;
    synchronized(WAIT_FOR_A) {
      WAIT_FOR_A.notifyAll();
    }
  }

  public void run() {
    for (int i = 0; i < Z<<1; i++) {
      //stelle sicher, dass a aktuell ist;
      synchronized(WAIT_FOR_A) {
        while (actualA != i) try {
          WAIT_FOR_A.wait();
        } catch (InterruptedException e) {}
      }
      System.out.println("Thread "+ID+": a = "+a);
      int copy = a;

      //erlaube das überschreiben von a
      desiredA++;
      //und benachrichtige den, der darauf wartet
      synchronized(WAIT_FOR_WRITE) {
        WAIT_FOR_WRITE.notifyAll();
      }

      //übergebe wert an Ziel
      if ((i & 1) == 0) shuffleTarget.setA(copy, i+1);
      else exchangeTarget.setA(copy, i+1);
    }
  }
}